/*
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

#include <string.h>
#include <math.h>

#include "io.h"

#define PI 3.14159265358979323846
#define E 2.71828182845904523536
#define EU 6.559538525
#define HALF_PI PI*0.5
#define CACHE 15
#define SHIFT4 4
#define SHIFT8 8
#define SHIFT16 16
#define SHIFT20 20
#define SHIFT25 25
#define ERROR_CREATE_FUNCTION 1
#define DEFAULT_TYPE 2147483647
#define DEFAULT_VAL -1.0

#define MAX_FUNCTIONS_ALPHABET 26
#define MAX_FUNCTIONS 16

struct func
	{
	 unsigned long type ;
	 double val ;
	 struct func* left ;
	 struct func* right ;
	} ;
typedef struct func function ;


void initialise_f( function* f) ;
int verifyLoop( function* f , function* compar ) ;
void destroy_f( function* f ) ;
void copy_f( function* b, function* a ) ; // b <- a
double eval_f( function* f, double x ) ;
int create_tree(char* string, unsigned long len, function* f ) ;
int create_f( char* string, function* f ) ;








